#ifndef DOWNLOADMANAGER_H
#define DOWNLOADMANAGER_H

#include <qobject.h>

#include <vector>
#include <string>

class QTimer;
class QListViewItem;
class QueryHitEntry;
class QtellaSub;
class QSocket;
class Download;

using namespace std;

class DownloadManager : public QObject
{
 Q_OBJECT

public:
 DownloadManager(QtellaSub* parent);

 //! Add download.
 /*!
   \param qhe object of the search result
   \param item pointer to the item in the search result list
   \param dest new filename (without directory)
 */
 void              addDownload(QueryHitEntry& qhe, QListViewItem* item, std::string dest = "", QListViewItem* i = NULL);

 //! Returns the number of active downloads.
 int               numberOfDownloads();

 void              abortDownload(QueryHitEntry& qhe);
 void              deleteDownload(QueryHitEntry& qhe);

 void              updatePush(std::string data, QSocket* socket);

 QtellaSub*                  _parent;
 std::vector<Download*>      _downloads;

private:
 QTimer*                     _update_timer;

public slots:
  void              slotUpdate();
  void              slotAbortDownload();
  void              slotResumeDownload();
  void              slotRemoveDownload();
  void              slotClearInactive();
  void              slotDelete();
};

#endif
