#ifndef INTERRUPTED_DOWNLOADS_H
#define INTERRUPTED_DOWNLOADS_H

#include "InterruptedFile.h"
#include "QueryHitEntry.h"

#include <string>
#include <map>
#include <vector>

#include <qobject.h>
#include <qpoint.h>

class QtellaSub;
class QListViewItem;
class QPopupMenu;

class InterruptedDownloads : public QObject
{
  Q_OBJECT

 public:
  InterruptedDownloads(QtellaSub* parent, std::string directory);

  void         update();
  void         getSelectedFiles(std::vector<InterruptedFile>& files);

  void         newQueryHit(unsigned long filesize);
  void         removeQueryHit(unsigned long filesize);

  void         setYellow(QListViewItem* item);
  void         setRed(QListViewItem* item);
  void         setGreen(QListViewItem* item);
  void         setSmile(QListViewItem* item);

  void         clearColored(QListViewItem* item);

 private:
  void         updateBall(QListViewItem* item);

  std::map<QListViewItem*, InterruptedFile>  _file_map;
  std::map<QListViewItem*, QueryHitEntry>    _qhe;

  QtellaSub*        _parent;
  std::string       _directory;
  QPopupMenu*       _context_menu;

 public slots:
  virtual void      slotShowContextMenu(QListViewItem*, const QPoint&, int);

  virtual void      deleteSelectedFiles();
  virtual void      resumeSelectedFiles();
  virtual void      searchSelectedFiles();
  virtual void      abortSelectedFiles();
};

#endif
