#include "Interface.h"

#include <sys/socket.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <linux/sockios.h>
#include <linux/if.h>
#include <netinet/in.h>

#include <iostream>
#include <strstream>
#include <fstream>

Interface::Interface()
{
}

void Interface::getIfList(std::vector<std::string>& v)
{
  fstream f;
  char    buffer[1024];

  f.open("/proc/net/dev", std::ios::in);
  if(f)
    while(f.getline(buffer, 1024))
      {
	std::string s(buffer);
	std::string::size_type idx = s.find(":");
	
	if(idx == std::string::npos) continue;
	
	s = s.substr(0, idx);
	idx = s.find_last_of(" ");
	if(idx != std::string::npos) s = s.substr(idx+1);
	v.push_back(s);
      }
}

std::string Interface::getIfAddress(std::string iface)
{
  std::string ifa(iface + std::string("\0", 1));
  std::strstream str;
  struct ifreq s;

  int fd = socket(PF_INET, SOCK_DGRAM, 0);

  for(int i=0; i < iface.size()+1; ++i) s.ifr_ifrn.ifrn_name[i] = ifa[i];

  if( ioctl(fd, SIOCGIFADDR, &s) ) return "";

  for(int i = 2; i < 6; ++i)
    {
      str << static_cast<unsigned int>(static_cast<unsigned char>(s.ifr_addr.sa_data[i]));
      if(i < 5) str << "."; else str << std::ends; 
    } 
  
  std::string sret(str.str());
  str.freeze(false);
  return sret;
}
