#include "../include/InterruptedFileSearch.h"
#include "QtellaSub.h"
#include "Connections.h"
#include "Search.h"
#include "QueryHitEntry.h"
#include <qlistbox.h>
#include <vector>

/* 
 *  Constructs a InterruptedFileSearch which is a child of 'parent', with the 
 *  name 'name' and widget flags set to 'f' 
 *
 *  The dialog will by default be modeless, unless you set 'modal' to
 *  TRUE to construct a modal dialog.
 */
InterruptedFileSearch::InterruptedFileSearch( QWidget* parent,  const char* name, bool modal, WFlags fl )
    : BInterruptedFileSearch( parent, name, modal, fl )
{
}

/*  
 *  Destroys the object and frees any allocated resources
 */
InterruptedFileSearch::~InterruptedFileSearch()
{
    // no need to delete child widgets, Qt does it all for us
}

void InterruptedFileSearch::init(unsigned long filesize)
{
  QtellaSub* p = QtellaSub::getInstance();

  std::vector<Search*>::iterator pos;
  for(pos = p->connections->_search.begin(); pos != p->connections->_search.end(); ++pos)
    for(int i = 0; i < (*pos)->vSearchResults.size(); ++i)
      if((*pos)->vSearchResults[i]->size == filesize) 
	{
	  ui_listbox->insertItem((*pos)->vSearchResults[i]->filename.c_str());
	  _file_list.push_back((*pos)->vSearchResults[i]);
	}
}

QueryHitEntry* InterruptedFileSearch::getSelectedQueryHit()
{
  return _file_list[ui_listbox->currentItem()];
}

void InterruptedFileSearch::slotResume()
{
  if(ui_listbox->currentItem() != -1) emit accept();
}
